#include <tap.h>
#include "libFireBird.h"

TAP_ID( 0x8100fe1f );
#define TAPNAME "Deselect"
TAP_PROGRAM_NAME(TAPNAME " v1.1");
TAP_AUTHOR_NAME("R2-D2 & mvordeme");
TAP_DESCRIPTION("Deselects the AV on timer boot");
TAP_ETCINFO(__DATE__);

dword keyEvtHndlr = 0;
dword reselect = 0;

void deselect() {
  CallFirmwareA(keyEvtHndlr, 0xE300, RKEY_TvSat);
}

dword TAP_EventHandler(word event, dword param1, dword param2) {
  if (event == EVT_KEY && reselect == 0) {
    reselect = 1;
  }
  else if (event == EVT_IDLE && reselect == 1) {
    reselect = 2;

    deselect();
    TAP_Print("deselect: re-selecting\n");
    TAP_Exit();
  }

  return param1;
}

int TAP_Main(void) {
  dword *codeSeg;

  if (BootReason() != BOOT_TIMER)
    return 0;

  InitTAPex();

  codeSeg = (dword*)FindInstructionSequence(
    "3404e300 3c050001 0c042012 34a50022 241e000a 3c150001 36b50013 3404e300",
    "FFFFFFFF FFFFFFFF FC000000 FFFFFFFF FFFFFFFF FFF0FFFF FF00FFF0 FFFFFFFF",
    0x800C0000, 0x80180000, 0, FALSE);

  if (codeSeg == NULL) {
    TAP_Print("deselect: unsupported firmware (fw: %d:%x)\n",SysID,ApplID);

    return 0;
  }

  keyEvtHndlr = ABS_ADDR(codeSeg[2]);

  if (! PatchIsInstalled((dword*)0x80000000, "Ds")) {
      TAP_Print("deselect: deselecting %p\n", keyEvtHndlr);
      deselect();
    }

  return 1;
}
